package apis

import (
	"fmt"

	"github.com/gin-gonic/gin"
	"github.com/gin-gonic/gin/binding"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineCoinnetwork struct {
	api.Api
}

// GetPage 获取【币种网络】列表
// @Summary 获取【币种网络】列表
// @Description 获取【币种网络】列表
// @Tags 【币种网络】
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineCoinnetwork}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-coinnetwork [get]
// @Security Bearer
func (e LineCoinnetwork) GetPage(c *gin.Context) {
	req := dto.LineCoinnetworkGetPageReq{}
	s := service.LineCoinnetwork{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req, binding.Form, binding.Query).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineCoinnetwork, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取【币种网络】失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取【币种网络】
// @Summary 获取【币种网络】
// @Description 获取【币种网络】
// @Tags 【币种网络】
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineCoinnetwork} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-coinnetwork/{id} [get]
// @Security Bearer
func (e LineCoinnetwork) Get(c *gin.Context) {
	req := dto.LineCoinnetworkGetReq{}
	s := service.LineCoinnetwork{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineCoinnetwork

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取【币种网络】失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Insert 创建【币种网络】
// @Summary 创建【币种网络】
// @Description 创建【币种网络】
// @Tags 【币种网络】
// @Accept application/json
// @Product application/json
// @Param data body dto.LineCoinnetworkInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-coinnetwork [post]
// @Security Bearer
func (e LineCoinnetwork) Insert(c *gin.Context) {
	req := dto.LineCoinnetworkInsertReq{}
	s := service.LineCoinnetwork{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建【币种网络】失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改【币种网络】
// @Summary 修改【币种网络】
// @Description 修改【币种网络】
// @Tags 【币种网络】
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineCoinnetworkUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-coinnetwork/{id} [put]
// @Security Bearer
func (e LineCoinnetwork) Update(c *gin.Context) {
	req := dto.LineCoinnetworkUpdateReq{}
	s := service.LineCoinnetwork{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改【币种网络】失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "修改成功")
}

// Delete 删除【币种网络】
// @Summary 删除【币种网络】
// @Description 删除【币种网络】
// @Tags 【币种网络】
// @Param data body dto.LineCoinnetworkDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-coinnetwork [delete]
// @Security Bearer
func (e LineCoinnetwork) Delete(c *gin.Context) {
	s := service.LineCoinnetwork{}
	req := dto.LineCoinnetworkDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除【币种网络】失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "删除成功")
}
